/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-robotnik-msgs-0.1.0-0raring-20150326-2153/msg/Interfaces.msg
 *
 */


#ifndef ROBOTNIK_MSGS_MESSAGE_INTERFACES_H
#define ROBOTNIK_MSGS_MESSAGE_INTERFACES_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <robotnik_msgs/Data.h>
#include <robotnik_msgs/Data.h>

namespace robotnik_msgs
{
template <class ContainerAllocator>
struct Interfaces_
{
  typedef Interfaces_<ContainerAllocator> Type;

  Interfaces_()
    : total()
    , interfaces()  {
    }
  Interfaces_(const ContainerAllocator& _alloc)
    : total(_alloc)
    , interfaces(_alloc)  {
    }



   typedef  ::robotnik_msgs::Data_<ContainerAllocator>  _total_type;
  _total_type total;

   typedef std::vector< ::robotnik_msgs::Data_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::robotnik_msgs::Data_<ContainerAllocator> >::other >  _interfaces_type;
  _interfaces_type interfaces;




  typedef boost::shared_ptr< ::robotnik_msgs::Interfaces_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::robotnik_msgs::Interfaces_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct Interfaces_

typedef ::robotnik_msgs::Interfaces_<std::allocator<void> > Interfaces;

typedef boost::shared_ptr< ::robotnik_msgs::Interfaces > InterfacesPtr;
typedef boost::shared_ptr< ::robotnik_msgs::Interfaces const> InterfacesConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::robotnik_msgs::Interfaces_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::robotnik_msgs::Interfaces_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace robotnik_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'robotnik_msgs': ['/tmp/buildd/ros-hydro-robotnik-msgs-0.1.0-0raring-20150326-2153/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::robotnik_msgs::Interfaces_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::robotnik_msgs::Interfaces_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::robotnik_msgs::Interfaces_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::robotnik_msgs::Interfaces_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::robotnik_msgs::Interfaces_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::robotnik_msgs::Interfaces_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::robotnik_msgs::Interfaces_<ContainerAllocator> >
{
  static const char* value()
  {
    return "2cae798f4cdadfdb2326b84ac55dc3ea";
  }

  static const char* value(const ::robotnik_msgs::Interfaces_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x2cae798f4cdadfdbULL;
  static const uint64_t static_value2 = 0x2326b84ac55dc3eaULL;
};

template<class ContainerAllocator>
struct DataType< ::robotnik_msgs::Interfaces_<ContainerAllocator> >
{
  static const char* value()
  {
    return "robotnik_msgs/Interfaces";
  }

  static const char* value(const ::robotnik_msgs::Interfaces_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::robotnik_msgs::Interfaces_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# Contains the total number of bytes and pkts\n\
Data total\n\
# Contains information of every interface\n\
Data[] interfaces\n\
\n\
\n\
================================================================================\n\
MSG: robotnik_msgs/Data\n\
string interface\n\
float32 bytes_sent\n\
float32 bytes_received\n\
string units_sent\n\
string units_received\n\
int32 packages_sent\n\
int32 packages_received\n\
\n\
";
  }

  static const char* value(const ::robotnik_msgs::Interfaces_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::robotnik_msgs::Interfaces_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.total);
      stream.next(m.interfaces);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct Interfaces_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::robotnik_msgs::Interfaces_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::robotnik_msgs::Interfaces_<ContainerAllocator>& v)
  {
    s << indent << "total: ";
    s << std::endl;
    Printer< ::robotnik_msgs::Data_<ContainerAllocator> >::stream(s, indent + "  ", v.total);
    s << indent << "interfaces[]" << std::endl;
    for (size_t i = 0; i < v.interfaces.size(); ++i)
    {
      s << indent << "  interfaces[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::robotnik_msgs::Data_<ContainerAllocator> >::stream(s, indent + "    ", v.interfaces[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // ROBOTNIK_MSGS_MESSAGE_INTERFACES_H
